/*
 * Copyright (c) Members of the EGEE Collaboration. 2004.
 * See http://www.eu-egee.org/partners/ for details on the copyright holders.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *  GLite Data Transfer Agents: NameGenerationException Class
 *
 *  Authors: Paolo Badino <paolo.badino@cern.ch>
 *  Version info: $Id: NameGenerationException.h,v 1.2 2006/08/14 08:37:50 badino Exp $
 *  Release: $Name:  $
 *
 */
#ifndef GLITE_DATA_TRANSFER_AGENTS_NAMEGEN_NAMEGENERATIONEXCEPTION_H_
#define GLITE_DATA_TRANSFER_AGENTS_NAMEGEN_NAMEGENERATIONEXCEPTION_H_

#include "glite/data/agents/AgentExceptions.h"

namespace glite    {
namespace data     {
namespace transfer {
namespace agent    {
namespace namegen  {
    
/**
 * The Exception is thrown when an error happens on CertProxyService
 */
class NameGenerationException : public glite::data::agents::ExecutionError {
public:

    /**
     * Constructor
     * @param reason [IN] the reason of the error
     */
    NameGenerationException(const std::string& reason):glite::data::agents::ExecutionError(reason){}

    /**
     * Destructor
     */
    virtual ~NameGenerationException() throw() {}
    
private:

    /**
     * Default Constructor Not Implemented
     */
    NameGenerationException();
};

} // end namespace namegen
} // end namespace agent
} // end namespace transfer
} // end namespace data
} // end namespace glite

#endif //GLITE_DATA_TRANSFER_AGENTS_NAMEGEN_NAMEGENERATIONEXCEPTION_H_
